use utf8;

sub fichiermp {
  my ($r, $id, $pre, $index) = @_;
  open  MP, ">fichiers-mp/$id-$pre.mp";
  binmode(MP,":utf8");
  my $mp = "";
  $mp .= "%% Fichier généré le ".qx{date};
  $mp .= "%% ===================================================================\n\n";
  $mp .= "$pre = $index;\n";
  $mp .= "%% Informations administratives --------------------------------------\n";
  $mp .= "Nom[$pre] = \"" .$r->{$id}->{Nom}."\";\n";
  $mp .= "Prefecture[$pre] = \"".$r->{$id}->{Prefecture}."\";\n";
  $mp .= "PrefectureXY[$pre] = ".sprintf("(%06f,%06f);\n",&Geo2Rect(split(/\,/,$r->{$id}->{CoordsPrefecture},2)));
  print MP $mp;
  print MP &Limites2mp($r->{$id}->{Limites},$pre);
  close MP;
  &mkPrevisualisation($id, $pre);
}


sub Limites2mp {
  my ($r, $pre) = @_;
  my $nb = scalar @$r;
  my $mp = "";
  $mp .= "%% Nombre de contours ------------------------------------------------\nContours[$pre] = $nb;\n";
  $mp .= "%% Contours ----------------------------------------------------------\n";
  for (my $i = 0; $i < $nb; $i++) {
    $mp .= "Contour[$pre][".eval($i + 1)."] = ";
    my @liste = split(/\s+/, $r->[$i]);
    foreach (split(/\s+/, $r->[$i])) {
      $mp .= sprintf("(%06f,%06f)--",&Geo2Rect(split(/\,/,$_,2)));
    }
    $mp .= "cycle;\n";
  }
  return $mp;
}
### ----------------------------------------------------------------------------
sub mkPNG {
  my $f = shift;
  qx{gs -sDEVICE=pngalpha -dBATCH -dNOPAUSE -dGraphicsAlphaBits=4 -dTextAlphaBits=4 -r288 -sOutputFile=$f-temp.png $f.pdf
     convert $f-temp.png -resize 66% $f.png
     rm -f $f-temp.png
  };
}

sub mkPrevisualisation {
  my ($id, $pre) = @_;
  my $temp = "/tmp/$$";
  mkdir $temp;
  qx{cp fichiers-mp/$id-$pre.mp $temp/};
  my $image = qx{cat departement.mp};
  $image =~ s/\$([a-z]+)/"defined \$$1 ? \$$1 : ''"/gee;
  open MP, ">$temp/image.mp"; print MP $image; close MP;
  qx{cd $temp && mp2pdf image.mp};
  qx{mv -f $temp/image-1.pdf preview/$id-$pre.pdf};
  qx{rm -rf $temp};
  &mkPNG("preview/$id-$pre");
}
1;