use Math::Trig;
### ----------------------------------------------------------------------------
my $x0_      = 7;
my $y0_      = 66;
my $lambda0_ = 0.0523599;
my $a_       = 63.78137;
my $rho0_    = 117.543;
my $e_       = 0.0818192;
my $n_       = 0.725608;
### ----------------------------------------------------------------------------
sub Geo2Rect {
  my ($lambda, $phi) = @_;
  $phi    = deg2rad($phi);
  $lambda = deg2rad($lambda);
  my $rho = cot($phi/2 + pi/4) * ((1 + $e_ * sin($phi))/(1 - $e_ * sin($phi))) ** ($e_/2);
  $rho = $rho0_ * $rho ** $n_;
  my $x = $x0_ + $rho * sin($n_ * ($lambda - $lambda0_));
  my $y = $y0_ + $rho0_ - $rho * cos($n_ * ($lambda - $lambda0_));
  return ($x,$y);
}
### ----------------------------------------------------------------------------
1;